var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
__export(exports, {
  fetchAllDocuments: () => fetchAllDocuments,
  getDocumentDefNameWithRelativeFilePathArray: () => getDocumentDefNameWithRelativeFilePathArray,
  makeCacheItemFromFilePath: () => makeCacheItemFromFilePath
});
var import_core = __toModule(require("@contentlayer/core"));
var import_core2 = __toModule(require("@contentlayer/core"));
var import_utils = __toModule(require("@contentlayer/utils"));
var import_fs = __toModule(require("fs"));
var import_glob_promise = __toModule(require("glob-promise"));
var import_gray_matter = __toModule(require("gray-matter"));
var yaml = __toModule(require("js-yaml"));
var os = __toModule(require("os"));
var path = __toModule(require("path"));
var import_ts_pattern = __toModule(require("ts-pattern"));
const fetchAllDocuments = ((_0) => __async(void 0, [_0], function* ({
  schemaDef,
  filePathPatternMap,
  contentDirPath,
  flags,
  options,
  previousCache
}) {
  const documentDefNameWithRelativeFilePathArray = yield getDocumentDefNameWithRelativeFilePathArray({
    contentDirPath,
    filePathPatternMap
  });
  const concurrencyLimit = os.cpus().length;
  const documents = yield (0, import_utils.promiseMapPool)(documentDefNameWithRelativeFilePathArray, ({ documentDefName, relativeFilePath }) => makeCacheItemFromFilePath({
    relativeFilePath,
    schemaDef,
    documentDefName,
    contentDirPath,
    flags,
    options,
    previousCache
  }), concurrencyLimit).then((_) => _.filter(import_utils.isNotUndefined));
  const cacheItemsMap = Object.fromEntries(documents.map((_) => [_.document._id, _]));
  return { cacheItemsMap };
}))["|>"]((0, import_utils.traceAsyncFn)("@contentlayer/source-local/fetchData:fetchAllDocuments", (_) => (0, import_utils.omit)(_, ["previousCache"])));
const getDocumentDefNameWithRelativeFilePathArray = (_0) => __async(void 0, [_0], function* ({
  filePathPatternMap,
  contentDirPath
}) {
  const documentDefNameWithRelativeFilePathsArray = yield Promise.all(Object.entries(filePathPatternMap).map((_02) => __async(void 0, [_02], function* ([documentDefName, filePathPattern]) {
    return {
      documentDefName,
      relativeFilePaths: yield (0, import_glob_promise.promise)(filePathPattern, { cwd: contentDirPath })
    };
  })));
  const documentDefNameWithRelativeFilePathArray = documentDefNameWithRelativeFilePathsArray.flatMap(({ documentDefName, relativeFilePaths }) => relativeFilePaths.map((relativeFilePath) => ({ relativeFilePath, documentDefName })));
  return documentDefNameWithRelativeFilePathArray;
});
const makeCacheItemFromFilePath = ((_0) => __async(void 0, [_0], function* ({
  relativeFilePath,
  schemaDef,
  documentDefName,
  contentDirPath,
  flags,
  options,
  previousCache
}) {
  const fullFilePath = path.join(contentDirPath, relativeFilePath);
  const documentHash = (yield import_fs.promises.stat(fullFilePath)).mtime.getTime().toString();
  if (previousCache && previousCache.cacheItemsMap[relativeFilePath] && previousCache.cacheItemsMap[relativeFilePath].documentHash === documentHash) {
    return previousCache.cacheItemsMap[relativeFilePath];
  }
  const fileContent = yield import_fs.promises.readFile(fullFilePath, "utf-8");
  const filePathExtension = relativeFilePath.toLowerCase().split(".").pop();
  const content = (0, import_ts_pattern.match)(filePathExtension).with("md", () => {
    const markdown = (0, import_gray_matter.default)(fileContent);
    return {
      kind: "markdown",
      data: __spreadProps(__spreadValues({}, markdown.data), { content: markdown.content })
    };
  }).with("mdx", () => {
    const markdown = (0, import_gray_matter.default)(fileContent);
    return {
      kind: "mdx",
      data: __spreadProps(__spreadValues({}, markdown.data), { content: markdown.content })
    };
  }).with("json", () => ({ kind: "json", data: JSON.parse(fileContent) })).when((_) => ["yaml", "yml"].includes(_ != null ? _ : ""), () => ({ kind: "yaml", data: yaml.load(fileContent) })).otherwise(() => {
    throw new Error(`Unsupported file extension "${filePathExtension}" for ${relativeFilePath}`);
  });
  const isValid = checkSchema({ content, relativeFilePath, documentDefName, schemaDef, flags });
  if (!isValid) {
    return void 0;
  }
  const documentDef = schemaDef.documentDefMap[documentDefName];
  const document = yield makeDocument({ documentDef, rawContent: content, schemaDef, relativeFilePath, options });
  const computedValues = yield getComputedValues({ documentDef, doc: document });
  if (computedValues) {
    Object.entries(computedValues).forEach(([fieldName, value]) => {
      document[fieldName] = value;
    });
  }
  return { document, documentHash };
}))["|>"]((0, import_utils.traceAsyncFn)("@contentlayer/source-local/fetchData:makeDocumentFromFilePath", (_) => (0, import_utils.omit)(_, ["previousCache"])));
function checkSchema({
  schemaDef,
  content,
  relativeFilePath,
  documentDefName,
  flags
}) {
  const documentDef = schemaDef.documentDefMap[documentDefName];
  if (documentDef === void 0) {
    throw new Error(`No matching document definition found for "${relativeFilePath}"`);
  }
  const existingDataFieldKeys = Object.keys(content.data);
  const requiredFields = documentDef.fieldDefs.filter((_) => _.required);
  const misingRequiredFields = requiredFields.filter((fieldDef) => !existingDataFieldKeys.includes(fieldDef.name));
  if (misingRequiredFields.length > 0) {
    const misingRequiredFieldsStr = misingRequiredFields.map((_, i) => `     ${i + 1}: ` + JSON.stringify(_)).join("\n");
    const message = `Missing required fields (type: "${documentDef.name}") for "${relativeFilePath}".
  Missing fields:
${misingRequiredFieldsStr}
`;
    switch (flags.onMissingOrIncompatibleData) {
      case "skip":
        console.log(`Skipping document. Reason: ${message}`);
        return false;
      case "skip-ignore":
        return false;
      case "fail":
        throw new Error(`Error: ${message}`);
    }
  }
  if (flags.onExtraData === "warn") {
    const schemaFieldNames = documentDef.fieldDefs.map((_) => _.name);
    const extraFieldKeys = existingDataFieldKeys.filter((fieldKey) => !schemaFieldNames.includes(fieldKey));
    if (extraFieldKeys.length > 0) {
      console.log(`Warning: Document (type: "${documentDef.name}") contained fields that are not defined in schema for "${relativeFilePath}".

Extra fields:
${extraFieldKeys.map((key) => `  ${key}: ${JSON.stringify(content.data[key])}`).join("\n")}
`);
    }
  }
  return true;
}
const makeDocument = (_0) => __async(void 0, [_0], function* ({
  rawContent,
  documentDef,
  schemaDef,
  relativeFilePath,
  options
}) {
  const docValues = yield (0, import_utils.promiseMapToDict)(documentDef.fieldDefs, (fieldDef) => getDataForFieldDef({
    fieldDef,
    rawFieldData: rawContent.data[fieldDef.name],
    schemaDef,
    options
  }), (fieldDef) => fieldDef.name);
  const _raw = {
    sourceFilePath: relativeFilePath,
    sourceFileName: path.basename(relativeFilePath),
    sourceFileDir: path.dirname(relativeFilePath),
    fileType: rawContent.kind,
    flattenedPath: getFlattenedPath(relativeFilePath)
  };
  const doc = __spreadValues({
    _typeName: documentDef.name,
    _id: relativeFilePath,
    _raw
  }, docValues);
  return doc;
});
const getFlattenedPath = (relativeFilePath) => {
  return relativeFilePath.split(".").slice(0, -1).join(".").replace(/\/index$/, "");
};
const makeObject = (_0) => __async(void 0, [_0], function* ({
  rawObjectData,
  fieldDefs,
  typeName,
  schemaDef,
  options
}) {
  const objValues = yield (0, import_utils.promiseMapToDict)(fieldDefs, (fieldDef) => getDataForFieldDef({
    fieldDef,
    rawFieldData: rawObjectData[fieldDef.name],
    schemaDef,
    options
  }), (fieldDef) => fieldDef.name);
  const obj = __spreadValues({ _typeName: typeName, _raw: {} }, objValues);
  return obj;
});
const getDataForFieldDef = (_0) => __async(void 0, [_0], function* ({
  fieldDef,
  rawFieldData,
  schemaDef,
  options
}) {
  if (rawFieldData === void 0) {
    if (fieldDef.required) {
      console.error(`Inconsistent data found: ${fieldDef}`);
    }
    return void 0;
  }
  switch (fieldDef.type) {
    case "object":
      const objectDef = schemaDef.objectDefMap[fieldDef.objectName];
      return makeObject({
        rawObjectData: rawFieldData,
        fieldDefs: objectDef.fieldDefs,
        typeName: objectDef.name,
        schemaDef,
        options
      });
    case "inline_object":
      return makeObject({
        rawObjectData: rawFieldData,
        fieldDefs: fieldDef.fieldDefs,
        typeName: "inline_object",
        schemaDef,
        options
      });
    case "reference":
      return rawFieldData;
    case "polymorphic_list":
    case "list":
      return (0, import_utils.promiseMap)(rawFieldData, (rawItemData) => getDataForListItem({ rawItemData, fieldDef, schemaDef, options }));
    case "date":
      return new Date(rawFieldData);
    case "markdown":
      return {
        raw: rawFieldData,
        html: yield (0, import_core2.markdownToHtml)({ mdString: rawFieldData, options: options == null ? void 0 : options.markdown })
      };
    case "mdx":
      return {
        raw: rawFieldData,
        code: yield (0, import_core.bundleMDX)({ mdxString: rawFieldData, options: options == null ? void 0 : options.mdx })
      };
    case "boolean":
    case "string":
    case "number":
    case "json":
    case "slug":
    case "text":
    case "url":
    case "enum":
    case "image":
      return rawFieldData;
    default:
      (0, import_utils.casesHandled)(fieldDef);
  }
});
const getDataForListItem = (_0) => __async(void 0, [_0], function* ({
  rawItemData,
  fieldDef,
  schemaDef,
  options
}) {
  if (typeof rawItemData === "string") {
    return rawItemData;
  }
  if (fieldDef.type === "polymorphic_list") {
    const objectTypeName = rawItemData[fieldDef.typeField];
    const objectDef = schemaDef.objectDefMap[objectTypeName];
    if (objectDef === void 0) {
      const valueTypeValues = fieldDef.of.filter((_) => _.type === "object").map((_) => _.objectName).join(", ");
      throw new Error(`Invalid value "${objectTypeName}" for type field "${fieldDef.typeField}" for field "${fieldDef.name}".
Needs to be one of the following values: ${valueTypeValues}`);
    }
    return makeObject({
      rawObjectData: rawItemData,
      fieldDefs: objectDef.fieldDefs,
      typeName: objectDef.name,
      schemaDef,
      options
    });
  }
  switch (fieldDef.of.type) {
    case "object":
      const objectDef = schemaDef.objectDefMap[fieldDef.of.objectName];
      return makeObject({
        rawObjectData: rawItemData,
        fieldDefs: objectDef.fieldDefs,
        typeName: objectDef.name,
        schemaDef,
        options
      });
    case "inline_object":
      return makeObject({
        rawObjectData: rawItemData,
        fieldDefs: fieldDef.of.fieldDefs,
        typeName: "inline_object",
        schemaDef,
        options
      });
    default:
      return rawItemData;
  }
});
const getComputedValues = (_0) => __async(void 0, [_0], function* ({
  doc,
  documentDef
}) {
  if (documentDef.computedFields === void 0) {
    return void 0;
  }
  const computedValues = yield (0, import_utils.promiseMapToDict)(documentDef.computedFields, (field) => field.resolve(doc), (field) => field.name);
  return computedValues;
});
//# sourceMappingURL=fetchData.js.map
