var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __objRest = (source, exclude) => {
  var target = {};
  for (var prop in source)
    if (__hasOwnProp.call(source, prop) && exclude.indexOf(prop) < 0)
      target[prop] = source[prop];
  if (source != null && __getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(source)) {
      if (exclude.indexOf(prop) < 0 && __propIsEnum.call(source, prop))
        target[prop] = source[prop];
    }
  return target;
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};
__export(exports, {
  fromLocalContent: () => fromLocalContent
});
var import_core = __toModule(require("@contentlayer/core"));
var import_utils = __toModule(require("@contentlayer/utils"));
var chokidar = __toModule(require("chokidar"));
var import_fs = __toModule(require("fs"));
var path = __toModule(require("path"));
var import_rxjs = __toModule(require("rxjs"));
var import_operators = __toModule(require("rxjs/operators"));
var import_fetchData = __toModule(require("./fetchData"));
var import_provideSchema = __toModule(require("./provideSchema"));
__reExport(exports, __toModule(require("./schema")));
__reExport(exports, __toModule(require("./types")));
const fromLocalContent = (argsOrArgsThunk) => __async(void 0, null, function* () {
  const _a = typeof argsOrArgsThunk === "function" ? yield argsOrArgsThunk() : argsOrArgsThunk, {
    contentDirPath,
    schema: documentDefs_,
    onMissingOrIncompatibleData = "skip",
    onExtraData = "warn"
  } = _a, options = __objRest(_a, [
    "contentDirPath",
    "schema",
    "onMissingOrIncompatibleData",
    "onExtraData"
  ]);
  const documentDefs = (Array.isArray(documentDefs_) ? documentDefs_ : Object.values(documentDefs_)).map((_) => _());
  return {
    type: "local",
    provideSchema: () => (0, import_provideSchema.makeCoreSchema)({ documentDefs }),
    fetchData: ({ watch }) => {
      const filePathPatternMap = documentDefs.reduce((acc, documentDef) => __spreadProps(__spreadValues({}, acc), { [documentDef.name]: documentDef.filePathPattern }), {});
      const flags = { onExtraData, onMissingOrIncompatibleData };
      const schemaDef = (0, import_provideSchema.makeCoreSchema)({ documentDefs });
      const initEvent = { _tag: "init" };
      let cache = void 0;
      const updates$ = watch ? (0, import_rxjs.defer)(() => (0, import_rxjs.fromEvent)(chokidar.watch(".", {
        cwd: contentDirPath,
        ignoreInitial: true,
        awaitWriteFinish: { stabilityThreshold: 50, pollInterval: 10 }
      }), "all")).pipe((0, import_operators.map)(chokidarAllEventToCustomUpdateEvent), (0, import_operators.tap)((e) => (e._tag === "update" || e._tag === "deleted") && console.log(`Watch event "${e._tag}": ${e.relativeFilePath}`)), (0, import_operators.startWith)(initEvent)) : (0, import_rxjs.of)(initEvent);
      return updates$.pipe((0, import_operators.mergeMap)((event) => __async(void 0, null, function* () {
        if (!cache) {
          cache = yield loadPreviousCacheFromDisk({ schemaHash: schemaDef.hash });
        }
        return event;
      })), (0, import_operators.mergeMap)((event) => __async(void 0, null, function* () {
        switch (event._tag) {
          case "init":
            return (0, import_fetchData.fetchAllDocuments)({
              schemaDef,
              filePathPatternMap,
              contentDirPath,
              flags,
              options,
              previousCache: cache
            });
          case "deleted": {
            delete cache.cacheItemsMap[event.relativeFilePath];
            return cache;
          }
          case "update": {
            return updateCacheEntry({
              contentDirPath,
              filePathPatternMap,
              cache,
              event,
              flags,
              schemaDef,
              options
            });
          }
          default:
            (0, import_utils.casesHandled)(event);
        }
      }))).pipe((0, import_operators.tap)((cache_) => __async(void 0, null, function* () {
        cache = cache_;
        yield writeCacheToDisk({ cache, schemaHash: schemaDef.hash });
      })));
    }
  };
});
const updateCacheEntry = (_0) => __async(void 0, [_0], function* ({
  contentDirPath,
  filePathPatternMap,
  cache,
  event,
  flags,
  schemaDef,
  options
}) {
  var _a;
  const documentDefNameWithFilePathArray = yield (0, import_fetchData.getDocumentDefNameWithRelativeFilePathArray)({
    contentDirPath,
    filePathPatternMap
  });
  const documentDefName = (_a = documentDefNameWithFilePathArray.find((_) => _.relativeFilePath === event.relativeFilePath)) == null ? void 0 : _a.documentDefName;
  if (!documentDefName) {
    console.log(`Tried to update cache. No matching document def found called ${documentDefName} for file ${event.relativeFilePath}`);
    return cache;
  }
  const cacheItem = yield (0, import_fetchData.makeCacheItemFromFilePath)({
    contentDirPath,
    documentDefName,
    relativeFilePath: event.relativeFilePath,
    flags,
    schemaDef,
    options,
    previousCache: cache
  });
  if (cacheItem) {
    cache.cacheItemsMap[event.relativeFilePath] = cacheItem;
  }
  return cache;
});
const chokidarAllEventToCustomUpdateEvent = ([eventName, relativeFilePath]) => {
  switch (eventName) {
    case "add":
    case "change":
      return { _tag: "update", relativeFilePath };
    case "unlink":
      return { _tag: "deleted", relativeFilePath };
    case "unlinkDir":
    case "addDir":
      return { _tag: "init" };
    default:
      (0, import_utils.casesHandled)(eventName);
  }
};
const loadPreviousCacheFromDisk = (_0) => __async(void 0, [_0], function* ({ schemaHash }) {
  const filePath = path.join((0, import_core.getArtifactsDir)(), "cache", `${schemaHash}.json`);
  try {
    const file = yield import_fs.promises.readFile(filePath, "utf8");
    return JSON.parse(file);
  } catch (e) {
    return void 0;
  }
});
const writeCacheToDisk = (_0) => __async(void 0, [_0], function* ({ cache, schemaHash }) {
  const cacheDirPath = path.join((0, import_core.getArtifactsDir)(), "cache");
  const filePath = path.join(cacheDirPath, `${schemaHash}.json`);
  yield import_fs.promises.mkdir(cacheDirPath, { recursive: true });
  yield import_fs.promises.writeFile(filePath, JSON.stringify(cache), "utf8");
});
//# sourceMappingURL=index.js.map
