var __create = Object.create;
var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};
__export(exports, {
  makeCoreSchema: () => makeCoreSchema
});
var import_core = __toModule(require("@contentlayer/core"));
var import_utils = __toModule(require("@contentlayer/utils"));
const makeCoreSchema = (0, import_utils.traceFn)("@contentlayer/source-local:makeCoreSchema")((schemaDef) => {
  var _a, _b, _c, _d;
  const coreDocumentDefMap = {};
  const coreObjectDefMap = {};
  for (const documentDef of schemaDef.documentDefs) {
    validateDefName({ defName: documentDef.name });
    const fieldDefs = Object.entries(documentDef.fields).map(fieldDefToCoreFieldDef);
    if ((documentDef.fileType === void 0 || documentDef.fileType === "markdown") && fieldDefs.every((_) => _.name !== "content")) {
      fieldDefs.push({
        type: "markdown",
        name: "content",
        label: "Markdown content",
        description: "Default markdown file content",
        default: void 0,
        const: void 0,
        hidden: void 0,
        required: void 0
      });
    }
    if (documentDef.fileType === "mdx" && fieldDefs.every((_) => _.name !== "content")) {
      fieldDefs.push({
        type: "mdx",
        name: "content",
        label: "MDX content",
        description: "Default MDX file content",
        default: void 0,
        const: void 0,
        hidden: void 0,
        required: void 0
      });
    }
    const computedFields = Object.entries((_a = documentDef.computedFields) != null ? _a : {}).map(([name, computedField]) => __spreadProps(__spreadValues({}, (0, import_utils.pick)(computedField, ["description", "resolve", "type"])), { name }));
    const coreDocumentDef = __spreadProps(__spreadValues({
      _tag: "DocumentDef"
    }, (0, import_utils.pick)(documentDef, ["name", "description", "labelField"])), {
      label: (_b = documentDef.label) != null ? _b : documentDef.name,
      isSingleton: (_c = documentDef.isSingleton) != null ? _c : false,
      fieldDefs,
      computedFields
    });
    coreDocumentDefMap[documentDef.name] = coreDocumentDef;
  }
  const objectDefs = collectObjectDefs(schemaDef.documentDefs);
  for (const objectDef of objectDefs) {
    validateDefName({ defName: objectDef.name });
    const coreObjectDef = __spreadProps(__spreadValues({
      _tag: "ObjectDef"
    }, (0, import_utils.pick)(objectDef, ["name", "description", "labelField"])), {
      label: (_d = objectDef.label) != null ? _d : objectDef.name,
      fieldDefs: Object.entries(objectDef.fields).map(fieldDefToCoreFieldDef)
    });
    coreObjectDefMap[coreObjectDef.name] = coreObjectDef;
  }
  const defs = { documentDefMap: coreDocumentDefMap, objectDefMap: coreObjectDefMap };
  const hash = (0, import_core.hashObject)(defs);
  return __spreadProps(__spreadValues({}, defs), { hash });
});
const validateDefName = ({ defName }) => {
  const firstChar = defName.charAt(0);
  if (firstChar.toLowerCase() === firstChar) {
    const improvedDefName = (0, import_utils.uppercaseFirstChar)(defName);
    console.warn(`Warning: A document or object definition name should start with a uppercase letter.
You've provided the name "${defName}" - please consider using "${improvedDefName}" instead.
`);
  }
};
const fieldDefToCoreFieldDef = ([name, fieldDef]) => {
  var _a;
  const baseFields = __spreadProps(__spreadValues({}, (0, import_utils.pick)(fieldDef, ["type", "default", "description", "required", "const", "hidden"])), {
    label: (_a = fieldDef.label) != null ? _a : name,
    name
  });
  switch (fieldDef.type) {
    case "list":
      return __spreadProps(__spreadValues({}, baseFields), { of: fieldListItemsToCoreFieldListDefItems(fieldDef.of) });
    case "polymorphic_list":
      return __spreadProps(__spreadValues({}, baseFields), {
        typeField: fieldDef.typeField,
        of: fieldDef.of.map(fieldListItemsToCoreFieldListDefItems)
      });
    case "object":
      return __spreadProps(__spreadValues({}, baseFields), { objectName: fieldDef.object().name });
    case "inline_object":
      const fieldDefs = Object.entries(fieldDef.fields).map(fieldDefToCoreFieldDef);
      return __spreadProps(__spreadValues({}, baseFields), { fieldDefs });
    case "reference":
      return __spreadProps(__spreadValues({}, baseFields), { documentName: fieldDef.document().name });
    case "enum":
      return __spreadProps(__spreadValues({}, baseFields), { options: fieldDef.options });
    default:
      return __spreadProps(__spreadValues({}, (0, import_utils.pick)(fieldDef, ["type", "default", "description", "label", "required", "const", "hidden"])), {
        name
      });
  }
};
const fieldListItemsToCoreFieldListDefItems = (listFieldItem) => {
  switch (listFieldItem.type) {
    case "boolean":
    case "string":
      return (0, import_utils.pick)(listFieldItem, ["labelField", "type"]);
    case "object":
      return {
        type: "object",
        labelField: listFieldItem.labelField,
        objectName: listFieldItem.object().name
      };
    case "enum":
      return {
        type: "enum",
        labelField: listFieldItem.labelField,
        options: listFieldItem.options
      };
    case "inline_object":
      return {
        type: "inline_object",
        labelField: listFieldItem.labelField,
        fieldDefs: Object.entries(listFieldItem.fields).map(fieldDefToCoreFieldDef)
      };
  }
};
function collectObjectDefs(documentDefs) {
  const objectDefMap = {};
  const traverseObjectDef = (objectDef) => {
    if (objectDef.name in objectDefMap) {
      return;
    }
    objectDefMap[objectDef.name] = objectDef;
    Object.values(objectDef.fields).forEach(traverseField);
  };
  const traverseField = (field) => {
    switch (field.type) {
      case "object":
        return traverseObjectDef(field.object());
      case "inline_object":
        return Object.values(field.fields).forEach(traverseField);
      case "polymorphic_list":
        return field.of.forEach(traverseListFieldItem);
      case "list":
        return traverseListFieldItem(field.of);
    }
  };
  const traverseListFieldItem = (listFieldItem) => {
    switch (listFieldItem.type) {
      case "object":
        return traverseObjectDef(listFieldItem.object());
    }
  };
  documentDefs.flatMap((_) => Object.values(_.fields)).forEach(traverseField);
  return Object.values(objectDefMap);
}
//# sourceMappingURL=provideSchema.js.map
