import type { Options, SourcePlugin } from '@contentlayer/core';
import type { DocumentDef, Thunk } from './schema';
export * from './schema';
export * from './types';
declare type Args = {
    schema: Thunk<DocumentDef>[] | Record<string, Thunk<DocumentDef>>;
    contentDirPath: string;
} & Options & Partial<Flags>;
export declare type Flags = {
    /**
     * Whether to print warning meassages if content has fields not definied in the schema
     * @default 'warn'
     */
    onExtraData: 'warn' | 'ignore';
    /**
     * Whether to skip or fail when encountering missing or incompatible data
     */
    onMissingOrIncompatibleData: 'skip' | 'fail' | 'skip-ignore';
};
declare type MakeSourcePlugin = (_: Args | Thunk<Args> | Thunk<Promise<Args>>) => Promise<SourcePlugin>;
export declare const fromLocalContent: MakeSourcePlugin;
//# sourceMappingURL=index.d.ts.map